#include <IRremote.h>
#include <IRremoteInt.h>

// Robot With IR remote
// by Neil Hendrick
//

//this imports the IR Library (must be present in libraries folder)
int dirbpinB = 12; // Direction pin for motor B is Digital 12
int speedbpinB = 9; // Speed pin for motor B is Digital 9 (PWM)
int dirbpinA = 13; // Direction pin for motor A is Digital 13
int speedbpinA = 10; // Speed pin for motor A is Digital 10 (PWM)
int speed = 100;
int dir = 0;
int RECV_PIN = 11;    // IR receiver
IRrecv irrecv(RECV_PIN);
decode_results results;
  
void setup()
{
pinMode(dirbpinB, OUTPUT);
pinMode(dirbpinA, OUTPUT);
    
Serial.begin(9600); //begin serial connection, prints output to your PD
irrecv.enableIRIn(); // Start the receiver

}

void loop(){ //start loop
    if (irrecv.decode(&results)) {
    if (results.value == 0x57439867) { //UP forward
digitalWrite(dirbpinB, 1); // set direction
digitalWrite(dirbpinA, 1); // set direction
analogWrite(speedbpinB, speed); // set speed (PWM)
analogWrite(speedbpinA, speed); // set speed (PWM)
    }// close UP 
     else if (results.value == 0x57439966) { //UP forward
digitalWrite(dirbpinB, 1); // set direction
digitalWrite(dirbpinA, 1); // set direction
analogWrite(speedbpinB, speed); // set speed (PWM)
analogWrite(speedbpinA, speed); // set speed (PWM)
    }// close UP 
     else if (results.value == 0x5743CC33) { //DOWN backward
digitalWrite(dirbpinB, 0); // set direction
digitalWrite(dirbpinA, 0); // set direction
analogWrite(speedbpinB, speed); // set speed (PWM)
analogWrite(speedbpinA, speed); // set speed (PWM)
     }
     else if (results.value == 0x57437887) { //LEFT
digitalWrite(dirbpinB, 1); // set direction
digitalWrite(dirbpinA, 1); // set direction
analogWrite(speedbpinB, speed); // set speed (PWM)
analogWrite(speedbpinA, 50); // set speed (PWM)
     }
     else if (results.value == 0x5743B44B) { //RIGHT
digitalWrite(dirbpinB, 1); // set direction
digitalWrite(dirbpinA, 1); // set direction
analogWrite(speedbpinB, 50); // set speed (PWM)
analogWrite(speedbpinA, speed); // set speed (PWM)
     }
     else if (results.value == 0x57438679) { //STOP *
analogWrite(speedbpinB, 0); // set speed (PWM)
analogWrite(speedbpinA, 0); // set speed (PWM)
     }
          else if (results.value == 0x574354AB) { //STOP OK
analogWrite(speedbpinB, 0); // set speed (PWM)
analogWrite(speedbpinA, 0); // set speed (PWM)
     }
          else if (results.value == 0x574355AA) { //STOP OK
analogWrite(speedbpinB, 0); // set speed (PWM)
analogWrite(speedbpinA, 0); // set speed (PWM)
     }
     else if (results.value == 0x57432CD3) { // Spin Left RW
digitalWrite(dirbpinB, 1); // set direction
digitalWrite(dirbpinA, 0); // set direction
analogWrite(speedbpinB, speed); // set speed (PWM)
analogWrite(speedbpinA, speed); // set speed (PWM)
     }
     else if (results.value == 0x5743AB54) { //Spin Right FF
digitalWrite(dirbpinB, 0); // set direction
digitalWrite(dirbpinA, 1); // set direction
analogWrite(speedbpinB, speed); // set speed (PWM)
analogWrite(speedbpinA, speed); // set speed (PWM)
     }
     else if (results.value == 0x5743AA55) { //Spin Right FF
digitalWrite(dirbpinB, 0); // set direction
digitalWrite(dirbpinA, 1); // set direction
analogWrite(speedbpinB, speed); // set speed (PWM)
analogWrite(speedbpinA, speed); // set speed (PWM)
     }
    Serial.println(results.value, HEX); //sends the IR code to computer so you can see what codes you are sending
    irrecv.resume(); // Receive the next value  
    
    }//close first IF "if (irrecv.decode(&results)){"
} //close loop
